Bug 989143 - Review Request: rubygem-charlock_holmes - Character encoding detecting library for Ruby using ICU
Review Request: rubygem-charlock_holmes - Character encoding detecting librar...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ken Dreyer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-27 17:23 EDT by Achilleas Pipinellis
Modified: 2013-08-23 19:55 EDT (History)
3 users (show)

See Also:
Fixed In Version: rubygem-charlock_holmes-0.6.9.4-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-23 19:55:31 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
ktdreyer: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Achilleas Pipinellis 2013-07-27 17:23:32 EDT
Spec URL: http://axilleas.fedorapeople.org/pkgs/rubygem-charlock_holmes/rubygem-charlock_holmes.spec
SRPM URL: http://axilleas.fedorapeople.org/pkgs/rubygem-charlock_holmes/rubygem-charlock_holmes-0.6.9.4-1.fc19.src.rpm

Description: Character encoding detecting library for Ruby using ICU

Fedora Account System Username: axilleas

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5665438
Comment 1 Ken Dreyer 2013-08-03 17:04:23 EDT
Thank you for packaging this! Here are two things I noticed mid-review:

My preference would be to remove bundler with sed during %prep instead of %check, so that we ship the modified helper.rb file that we actually used during testing.

It's ok to set LANG during %check, but I recommend filing a bug upstream on this. It's not valid for upstream to assume that LANG is set to anything, or en_US.utf-8 in particular.
Comment 3 Ken Dreyer 2013-08-06 00:11:37 EDT
I've noted two more issues below, but they are not blockers. Please fix them before importing the package to Fedora :)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues
==============
- The -doc package should not require /usr/bin/env. This is side-effect from
  RPM processing the shebang line "#!/usr/bin/env python" in
  test/fixtures/laholator.py. The following line will fix it:

  %global __requires_exclude ^/usr/bin/env$

  See https://github.com/axilleas/fedora/pull/5  :)

- Please remove the whitespace line at the top of %description. For some reason
  gem2rpm has put an extra line there before the text, and that actually does
  show up in the rpm -qpi.

Assuming you will fix these two, package is approved.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines. Yes, MIT.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Fully versioned dependency in subpackages, if present.

fedora-review found that there is no "Requires: %{name}%{?_isa} = %{version}-%{release}" in rubygem-charlock_holmes-doc, but since this is a noarch sub-package, I don't think that applies.

[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
As a general policy we should avoid requiring /usr/bin/env. See above.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir}, platform
     independent under %{gem_dir}.
     Yes, %{gem_extdir_mri} in this case.
[x]: Gem package must not define a non-gem subpackage
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane.
     See my comments above about /usr/bin/env.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
     Note: tested i386.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Ruby:
[x]: Specfile should use macros from rubygem-devel package.
[x]: Test suite of the library should be run.
[x]: Gem package should exclude cached Gem.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-charlock_holmes-0.6.9.4-2.fc19.i686.rpm
          rubygem-charlock_holmes-doc-0.6.9.4-2.fc19.noarch.rpm
rubygem-charlock_holmes-doc.noarch: W: spelling-error Summary(en_US) charlock -> char lock, char-lock, oarlock
rubygem-charlock_holmes-doc.noarch: W: spelling-error Summary(en_US) holmes -> Holmes, holes, homes
rubygem-charlock_holmes-doc.noarch: W: spelling-error %description -l en_US charlock -> char lock, char-lock, oarlock
rubygem-charlock_holmes-doc.noarch: W: spelling-error %description -l en_US holmes -> Holmes, holes, homes
2 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-charlock_holmes-doc rubygem-charlock_holmes
rubygem-charlock_holmes-doc.noarch: W: spelling-error Summary(en_US) charlock -> char lock, char-lock, oarlock
rubygem-charlock_holmes-doc.noarch: W: spelling-error Summary(en_US) holmes -> Holmes, holes, homes
rubygem-charlock_holmes-doc.noarch: W: spelling-error %description -l en_US charlock -> char lock, char-lock, oarlock
rubygem-charlock_holmes-doc.noarch: W: spelling-error %description -l en_US holmes -> Holmes, holes, homes
2 packages and 0 specfiles checked; 0 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-charlock_holmes-doc (rpmlib, GLIBC filtered):
    /usr/bin/env
    rubygem-charlock_holmes

rubygem-charlock_holmes (rpmlib, GLIBC filtered):
    libc.so.6
    libcrypt.so.1
    libdl.so.2
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libicui18n.so.50
    libm.so.6
    libpthread.so.0
    librt.so.1
    libruby.so.2.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)
    ruby(release)
    ruby(rubygems)



Provides
--------
rubygem-charlock_holmes-doc:
    rubygem-charlock_holmes-doc

rubygem-charlock_holmes:
    charlock_holmes.so
    rubygem(charlock_holmes)
    rubygem-charlock_holmes
    rubygem-charlock_holmes(x86-32)



Unversioned so-files
--------------------
rubygem-charlock_holmes: /usr/lib/gems/ruby/charlock_holmes-0.6.9.4/lib/charlock_holmes/charlock_holmes.so

Source checksums
----------------
https://rubygems.org/gems/charlock_holmes-0.6.9.4.gem :
  CHECKSUM(SHA256) this package     : e52db7af0f7a652f55244455f84b4f1c09144f0d5e416f677a912f9147d6dfef
  CHECKSUM(SHA256) upstream package : e52db7af0f7a652f55244455f84b4f1c09144f0d5e416f677a912f9147d6dfef


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-19-i386
Command line :/usr/bin/fedora-review -b 989143
Comment 4 Achilleas Pipinellis 2013-08-06 02:39:52 EDT
> - The -doc package should not require /usr/bin/env. This is side-effect from
>   RPM processing the shebang line "#!/usr/bin/env python" in
>   test/fixtures/laholator.py. The following line will fix it:
> 
>   %global __requires_exclude ^/usr/bin/env$
> 
>   See https://github.com/axilleas/fedora/pull/5  :)
> 

Thanks for the PR :) Some (many) questions about this.

1. Is this mentioned somewhere in the Packaging guidelines? After declaring this %global do I still need to remove the shebang (I would guess yes, see 2)? And if so, this %global is only for fixing the RPM's autorequires?

2. I tried to to make the file executable in %install. Would it be better if I removed the shebang in %prep instead?
In general is it preferred to remove the shebang from executables rather than `chmod +x` them?


> - Please remove the whitespace line at the top of %description. For some
> reason
>   gem2rpm has put an extra line there before the text, and that actually does
>   show up in the rpm -qpi.
> 

Nice catch, fixed ;)
Comment 5 Achilleas Pipinellis 2013-08-06 02:44:47 EDT
Something that I thought after submitting my thoughts above:

If I remove the shebang in %prep, then I guess the `%global __requires_exclude ^/usr/bin/env$` isn't needed, right?
Comment 6 Ken Dreyer 2013-08-06 03:22:00 EDT
In general, upstreams often set shebangs to "#!/usr/bin/env python" or "#!/usr/bin/env ruby". They do this to stay portable, but it is not really ideal for Fedora.

If the executable is a script that the user is really supposed to run, then you should swap out the /usr/bin/env for the actual executable, eg. /usr/bin/ruby or /usr/bin/python. I'm not sure that this is codified in any of the formal guidelines. There was a push to get this standardized back in 2009:

https://fedoraproject.org/wiki/Script_Interpreters_%28draft%29

but this effort did not reach completion, as there are still several packages that have Requires: /usr/bin/env.

In this particular case, even if we swapped /usr/bin/env for /usr/bin/python, we still have the dependency problem where the -doc subpackage Requires python. Technically speaking, a user should not need Python in order to simply install a ruby -doc package. It's just added dependency bloat at that point.

The reason that I preferred to use a Requires filter is that it felt less invasive to me than patching the source. I'm not intimately familiar with the reasons for why there was a Python file in that section of the tree to begin with. Since it's in "fixtures" I assume it's basically test data, but I didn't know what unintended side effect an actual patch to remove the shebang might bring. Ditto with chmod'ing. Since this is just in -doc, and the script doesn't really have to run directly, I figured the RPM Requires filter would be the simplest thing to keep us closer to upstream. https://fedoraproject.org/wiki/Staying_close_to_upstream_projects

It's your package, so ultimately if you want to try to patch it out instead of using a Requires filter, that's fine - TMTOWTDI. Just as long as we aren't adding another RPM to the pile packages that happen to require /usr/bin/env.
Comment 7 Achilleas Pipinellis 2013-08-07 05:07:04 EDT
Ok, got it thanks!
Comment 8 Achilleas Pipinellis 2013-08-07 05:09:07 EDT
New Package SCM Request
=======================
Package Name: rubygem-charlock_holmes
Short Description: Character encoding detecting library for Ruby using ICU
Owners: axilleas
Branches: f19
InitialCC:
Comment 9 Gwyn Ciesla 2013-08-07 08:13:46 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2013-08-07 10:19:40 EDT
rubygem-charlock_holmes-0.6.9.4-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rubygem-charlock_holmes-0.6.9.4-3.fc19
Comment 11 Fedora Update System 2013-08-07 19:02:02 EDT
rubygem-charlock_holmes-0.6.9.4-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 12 Fedora Update System 2013-08-23 19:55:31 EDT
rubygem-charlock_holmes-0.6.9.4-3.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.